""" Patches module. This module contains monkey-patching and workarounds for specific versions. """

from infi.shell.utils.streams import UnicodeSafeStreamWrapper

def _unicode_safe_stream_wrapper_init(self, stream):
    self._UnicodeSafeStreamWrapper__stream = stream
    encoding = getattr(stream, "encoding", None)
    if not encoding or encoding.upper() != "UTF-8":
        self._UnicodeSafeStreamWrapper__prewrite = lambda s: s.encode("UTF-8", "ignore")
    else:
        self._UnicodeSafeStreamWrapper__prewrite = lambda s: s
    self._enabled = True

UnicodeSafeStreamWrapper.__init__ = _unicode_safe_stream_wrapper_init